import re

@plugin
class Karma(object):
    def __init__(self, server):
        self.server = server
        self.prnt = server.prnt
        
        self.commands = [ "karma" ]
        
        self.server.handle("message", self.handle_message)
        self.server.handle("command", self.handle_command, self.commands)
        
        self.userpoints = { }
        
        self.karma_re = re.compile("^.+(\+\+|\-\-).*$")
    
    def handle_command(self, channel, user, cmd, args):
        if len(args) < 1:
            self.server.doMessage(channel, user+": Displays the amount of karma a user has. Usage: karma <nickname>")
            return
        
        if cmd == "karma":
            if self.userpoints.get(channel, None) is None:
                self.userpoints[channel] = {}
            
            nick = args[0].lower()
            if self.userpoints[channel].get(nick, None) is None:
                self.userpoints[channel][nick] = 0
                
            self.server.doMessage(channel, user+": "+args[0]+" has "+str(self.userpoints[channel][nick])+" points.")
            
    def handle_message(self, channel, user, message):
        if self.karma_re.match(message):
            ulist = [u for u in message.split(";") if u != '']
            addlist = [u[:-2] for u in ulist if u.endswith("++")]
            sublist = [u[:-2] for u in ulist if u.endswith("--")]
            
            for nick in addlist:
                if self.userpoints[channel].get(nick, None) is None:
                    self.userpoints[channel][nick] = 1
                else:
                    self.userpoints[channel][nick] += 1
            
            for nick in sublist:
                if self.userpoints[channel].get(nick, None) is None:
                    self.userpoints[channel][nick] = -1
                else:
                    self.userpoints[channel][nick] -= 1
