import sys

@plugin
class PluginLoader(object):
    def __init__(self, server):
        self.server = server
        self.server.pluginManager.loadPlugin("Auth")
        self.commands = ["load", "unload", "reload", "reloadall", "loaded", "allplugins"]
        self.server.handle("command", self.handle_command, self.commands)
        
    def handle_command(self, channel, user, cmd, args):
        if self.server.getPlugin("auth").isMod(user):
            if cmd == "reloadall":
                self.server.pluginManager.unloadAllPlugins()
                self.server.pluginManager.loadAllPlugins()
                self.server.doMessage(channel, user+": Reloaded all plugins")
            elif cmd == "allplugins":
                self.server.doMessage(channel, user+": Available plugins: "+" ".join(sys.modules["irc"].plugins.pList.keys()))
                return
                
            if len(args) < 1:
                self.server.doMessage(channel, user+": Not enough arguments.")
                return
            
            if cmd == "load":
                if self.server.pluginManager.pluginExists(args[0]):
                    if self.server.pluginManager.loadedPlugin(args[0]):
                        self.server.doMessage(channel, user+": Plugin "+args[0]+" has already been loaded")
                    else:
                        self.server.pluginManager.loadPlugin(args[0])
                        self.server.doMessage(channel, user+": Successfully loaded plugin "+args[0])
                else:
                    self.server.doMessage(channel, user+": No such plugin "+args[0])
            elif cmd == "unload":
                if self.server.pluginManager.pluginExists(args[0]):
                    if self.server.pluginManager.loadedPlugin(args[0]):
                        self.server.pluginManager.unloadPlugin(args[0])
                        self.server.doMessage(channel, user+": Successfully unloaded plugin "+args[0])
                    else:
                        self.server.doMessage(channel, user+": Plugin "+args[0]+" has not been loaded")
                else:
                    self.server.doMessage(channel, user+": No such plugin "+args[0])
            elif cmd == "reload":
                if self.server.pluginManager.pluginExists(args[0]):
                    if self.server.pluginManager.loadedPlugin(args[0]):
                        self.server.pluginManager.reloadPlugin(args[0])
                        self.server.doMessage(channel, user+": Successfully reloaded plugin "+args[0])
                    else:
                        self.server.doMessage(channel, user+": Plugin "+args[0]+" has not been loaded")
                else:
                    self.server.doMessage(channel, user+": No such plugin "+args[0])
            elif cmd == "loaded":
                if self.server.pluginManager.loadedPlugin(args[0]):
                    self.server.doMessage(channel, user+": Plugin "+args[0]+" is loaded")
                else:
                    if self.server.pluginManager.pluginExists(args[0]):
                        self.server.doMessage(channel, user+": Plugin "+args[0]+" is not loaded")
                    else:
                        self.server.doMessage(channel, user+": Plugin "+args[0]+" does not exist")
